﻿// Basic YinYang routines...
R = 300*.95/2;	// was Stage.height
Rh = R/2;
degToRad = Math.PI/180;
sqrt2 = Math.sqrt(2);
++initCtr;
if (initCtr > 1)
	trace("Script called twice");

function drawArc(mc, x,y,radius,bA,eA)
{
	var a = Math.tan(Math.PI/8);	// 22.5 for circle
	var r = radius;
	var theta = 45*degToRad;
	var cr = radius/Math.cos(theta/2);
	var angle = (bA+45)*degToRad;
	var cangle = angle-theta/2;
	var n = (eA-bA)/45;

	for (var i=0;i < n;i++,angle += theta,cangle += theta) 
	{
		var endX = r*Math.cos (angle);
		var endY = r*Math.sin (angle);
		var cX = cr*Math.cos (cangle);
		var cY = cr*Math.sin (cangle);
		mc.curveTo(cX+x,cY+y, endX+x,endY+y);
	}
}

function drawNegArc(mc, x,y,radius,bA,eA)
{
	var a = Math.tan(Math.PI/8);	// 22.5 for circle
	var r = radius;
	var theta = 45*degToRad;
	var cr = radius/Math.cos(theta/2);
	var angle = (bA+45)*degToRad;
	var cangle = angle-theta/2;
	var n = (eA-bA)/45;

	for (var i=0;i < n;i++,angle += theta,cangle += theta) 
	{
		var endX = r*Math.cos (angle);
		var endY = r*Math.sin (angle);
		var cX = cr*Math.cos (cangle);
		var cY = cr*Math.sin (cangle);
		mc.curveTo(x+cX,y-cY, x+endX,y-endY);
	}
}

function drawYin(mc, x, y, radius, fC, fA, withHole)
{
	var	rad2 = radius/2;
	mc.moveTo(x+radius,y);  // same as x+cos(0)*r, y+sin(0)*r
	mc.beginFill(fC,fA);
	drawArc(mc, x, y, radius, 0, 180);
	drawArc(mc, x-rad2,y, rad2, 180, 360);
	drawNegArc(mc, x+rad2,y, rad2, 180, 360);

//
	if (withHole) {
		var radC = rad2*(sqrt2-1);
		mc.moveTo(x+radC-rad2,y);
		drawArc(mc, x-rad2, y, radC, 0, 360);
	}
	mc.endFill();
}

// Unused - use this to fill in the other half of a 2-color design
function drawYang(mc, x, y, radius, fC, fA, withHole)
{
	var rad2 = radius/2;
	mc.moveTo(x-radius,y);  // same as x+cos(0)*r, y+sin(0)*r
	mc.beginFill(fC,fA);
	drawArc(mc, x, y, radius, 180, 360);
	drawArc(mc, x+rad2,y, rad2, 0, 180);
	drawNegArc(mc, x-rad2,y, rad2, 0, 180);

	if (withHole) {
		var radC = rad2*(sqrt2-1);
		mc.moveTo(x+rad2+radC,y);
		drawArc(mc, x+rad2, y, radC, 0, 360);
	}
	mc.endFill();
}

// unused
function drawCircle(mc, x,y,radius, fC,fA)
{
	mc.moveTo(x+radius,y);  // same as x+cos(0)*r, y+sin(0)*r
	mc.beginFill(fC,fA);
	drawArc(mc, x, y, radius, 0, 360);
	mc.endFill()
}

function drawCircleOutline(mc, x,y,radius, fC,fA,thick)
{
	mc.lineStyle(thick,fC,fA);
	mc.moveTo(x+radius,y);  // same as x+cos(0)*r, y+sin(0)*r
	// mc.beginFill(fC,fA);
	drawArc(mc, x, y, radius, 0, 360);
	// mc.endFill()
	mc.lineStyle(0);
}


MovieClip.prototype.drawObjectCell = function()
{
	var sr = R;
	var sr2 = Rh;
	var x = 0;
	var y = 0;
	this.clear();

	// These are the componenet parts of the yin-yang symbol, use which
	// ever ones you want...
	drawYin(this, 0, 0, sr, 0x000000, 75,true);
	drawYang(this, 0, 0, sr, 0x0000FF, 50,true);
	drawCircle(this,x-sr2,0,sr2*(sqrt2-1),0x0000FF,50);	// cicle within Yin
	drawCircle(this,x+sr2,0,sr2*(sqrt2-1),0x000000,75);	// circle within Yang
	drawCircleOutline(this,0,0,sr,0x000000,75,3);	// outline around whole
	
}

function update()
{
	this.yin._rotation += 1;
}

function init()
{
	// trace("Init 1");
	if (inited != undefined)
		return;
	// var h = this.attachMovie("dummy", "yin", 0);
	var h = this.createEmptyMovieClip("yin", 0);
	h._x = 150;
	h._y = 150;
	h.drawObjectCell();
	this.onEnterFrame = update;
	// h.Play();
	inited = true;
}

init();
